#include "point.h"
#include <cmath>

// Q2
point operator+(point a, point b) {
    a.x += b.x;
    a.y += b.y;
    return a;
}

// Q2
point operator-(point a, point b) {
    a.x -= b.x;
    a.y -= b.y;
    return a;
}

// Q3
point operator*(float f, point a) {
    a.x *= f;
    a.y *= f;
    return a;
}

// Q3
point operator*(point a, float f) {
    return f*a;
}

// Q3
point operator/(point a, float f) {
    return (1.0/f)*a;
}

// Q4
point affine(point p, float a, point shift) {
    return  p*a+shift;
}

// Q5
point rotate(point a, point center, float deg) {
    a = a-center;
    float c = cos(deg*M_PI/180), s = sin(deg*M_PI/180);
    float y = s*a.x + c*a.y;
    a.x = c*a.x - s*a.y;
    a.y = y;
    return a+center;
}
